#!/usr/local/bin/perl
require 5.004;
use strict;
#------------------------------------------------------------------------------
# ǡݡ for Movable Type
#                                                   (C)2006 nabe / nabe@abk.nu
#------------------------------------------------------------------------------
package Satsuki::Diary::ExportMT;
use Time::Local;
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;
	my $self  = {};
	bless($self, $class);		# $self 򤳤Υ饹ȴϢդ
	$self->{ROBJ}  = shift;

	return $self;
}

#------------------------------------------------------------------------------
# ڥǥȥ饯
#------------------------------------------------------------------------------
sub DESTROY {
}
###############################################################################
# ǡݡ
###############################################################################
#------------------------------------------------------------------------------
# Movable TypeΥǡݡ
#------------------------------------------------------------------------------
sub export {
	my ($self, $skelton, $logs, $option) = @_;
	my $ROBJ = $self->{ROBJ};

	# ʸѴ
	my $system_coding = $ROBJ->{System_coding};
	my $output_coding = $option->{MT_charset};
	my $jcode;
	if ($system_coding ne $output_coding) {
		$jcode = $ROBJ->loadpm('Jcode');
	}

	my $diary_obj  = $option->{diary_obj};
	my $hyphen_all = $option->{MT_hyphen};
	my $force_ymd  = $option->{force_ymd};
	#---------------------------------------------------------------------
	# βϤ¸
	#---------------------------------------------------------------------
	foreach (@$logs) {
		#-------------------------------------------------------------
		# ǡù
		#-------------------------------------------------------------
		if ($_->{enable}) { $_->{status}='Publish'; } else { $_->{status}='Draft'; }

		# ղù
		my $yyyymmdd = $_->{yyyymmdd};
		my $year = substr($yyyymmdd, 0, 4);
		my $mon  = substr($yyyymmdd, 4, 2);
		my $day  = substr($yyyymmdd, 6, 2);
		my $ymd_utc;
		eval { $ymd_utc = Time::Local::timegm(0, 0, 0, $day,$mon-1,$year); };
		my $tm = $_->{tm};		# ꤷƤ
		if ($ymd_utc && ($force_ymd || $tm-$ymd_utc>86400)) {
			# 00:00:00 ʤƥबΤ, pkey ­
			$tm = $ymd_utc + int($_->{pkey});
		}
		$_->{tm} = $tm;

		#-------------------------------------------------------------
		# ʸù
		#-------------------------------------------------------------
		$diary_obj->text_split_for_mt( $_ );
		# $_->{text}  $_->{parser} 
		# $_->{convert_breaks}, $_->{body}, $_->{ex_body}
		# ŬڤꤷƤ

		# Ƭϥե escape
		if ($hyphen_all) {
			$_->{body}    =~ s/\n-/\n&#45;/g;
			$_->{ex_body} =~ s/\n-/\n&#45;/g;
		} else {
			$_->{body}    =~ s/\n-----/\n&#45;----/g;
			$_->{ex_body} =~ s/\n-----/\n&#45;----/g;
		}

		#-------------------------------------------------------------
		# ȥμ¹
		#-------------------------------------------------------------
		$ROBJ->{tmp} = $_;
		my $day = $ROBJ->execute( $skelton );

		#-------------------------------------------------------------
		# 
		#-------------------------------------------------------------
		my $str = $ROBJ->chain_array( $day );
		if ($jcode) {
			$jcode->from_to(\$str, $system_coding, $output_coding);
		}
		print $str;
	}
	return 0;
}

###############################################################################
# ȥ֥롼
###############################################################################
#------------------------------------------------------------------------------
# <br>  \n ѹ
#------------------------------------------------------------------------------
sub br2lf {
	my $self = shift;
	foreach(@_) {
		$_ =~ s/\n//g;
		$_ =~ s/<br>/\n/g;
	}
	return $_[0];
}



1;
