#!/usr/local/bin/perl
require 5.004;
use strict;
#------------------------------------------------------------------------------
# ǡݡ for adiary(xml)
#                                                   (C)2006 nabe / nabe@abk.nu
#------------------------------------------------------------------------------
package Satsuki::Diary::Export_adiary;
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;
	my $self  = {};
	bless($self, $class);		# $self 򤳤Υ饹ȴϢդ
	$self->{ROBJ}  = shift;

	return $self;
}

#------------------------------------------------------------------------------
# ڥǥȥ饯
#------------------------------------------------------------------------------
sub DESTROY {
}
###############################################################################
# ǡݡ
###############################################################################
#------------------------------------------------------------------------------
# adiaryΥǡݡ
#------------------------------------------------------------------------------
sub export {
	my ($self, $skelton, $logs, $option) = @_;
	my $ROBJ = $self->{ROBJ};

	# ʸѴ
	my $system_coding = $ROBJ->{System_coding};
	my $output_coding = 'UTF-8';
	my $jcode;
	if (! $option->{adiary_eucjp} && $system_coding ne $output_coding) {
		$jcode = $ROBJ->loadpm('Jcode');
	}
	# ץ
	my @pkey2tm;
	my $key2tm  = $option->{adiary_key2tm};
	if ($key2tm) {
		foreach (@$logs) { $pkey2tm[ $_->{pkey} ] = $_->{tm}; }
	}
	my $id2link;
	if ($option->{adiary_id2link}) {
		my $tags = {};
		$ROBJ->loadpm("TextParser::TagPlugin::Tag_adiary", $tags);
		$id2link = $tags->{"adiary:day"}->{data};
	}
	my $no_writeinfo =  $option->{adiary_no_writeinfo};

	#---------------------------------------------------------------------
	# βϤ¸
	#---------------------------------------------------------------------
	foreach (@$logs) {
		my $yyyymmdd = $_->{yyyymmdd};
		$_->{year} = substr($yyyymmdd, 0, 4);
		$_->{mon}  = substr($yyyymmdd, 4, 2);
		$_->{day}  = substr($yyyymmdd, 6, 2);
		#-------------------------------------------------------------
		# ʸβùʵID  
		#-------------------------------------------------------------
		if ($_->{parser} =~ /^default/ && ($key2tm || $id2link) && $_->{_text} =~ /\[key:/) {
			my @back;
			$_->{_text} .= "\n";
			# ֥å䥨
			$_->{_text} =~ s/(<!--.*?-->|(?:\G|\n)>+(\[|\|\|).*?\n\#?(\]|\|\|)<+\n)/push(@back, $1), "\x01$#back\x01"/esg;
			$_->{_text} =~ s/(\{\{.*?\}\})/push(@back, $1), "\x01$#back\x01"/eg;
			$_->{_text} =~ s/(\{.*?\})/    push(@back, $1), "\x01$#back\x01"/eg;
			# key 
			if ($key2tm) {
				$_->{_text} =~ s/\[key:(\d+)([\]:])/
					'[key:' . ($pkey2tm[$1] || $1) . $2/eg;
				$_->{_text} =~ s/\[day:0(\d+)([\]:])/
					'[key:' . ($pkey2tm[$1] || $1) . $2/eg;
			}
			# id ̾󥯤˽񤭴
			if (ref($id2link)) {
				my %h = (thisyear => $_->{year}, thismon => $_->{mon}, thisday => $_->{day}, ROBJ => $ROBJ);
				$_->{_text} =~ s#\[(id:(?:(\d+)|[\w\-]+)[^\]]*)\]#
					if ($2) { "[$1]"; }
					else {
						my ($cmd, @ary) = split(':', $1);
						my $link = &$id2link(\%h, {}, $cmd, \@ary);
						$link =~ s/href="([^:]*?)"/href="$ROBJ->{Server_url}$1"/;
						$link;
					}
				#eg;
			}

			# ᤹
			$_->{_text} =~ s/\x01(\d+)\x01/$back[$1]/g;
			chop($_->{_text});
		}

		#-------------------------------------------------------------
		# ȥμ¹
		#-------------------------------------------------------------
		$ROBJ->{tmp} = $_;
		my $day = $ROBJ->execute( $skelton );

		#-------------------------------------------------------------
		# 
		#-------------------------------------------------------------
		my $str = $ROBJ->chain_array( $day );
		if ($jcode) {
			$jcode->from_to(\$str, $system_coding, $output_coding);
		}
		print $str;
	}
	return 0;
}

1;
