use 5.6.0;
use strict;
#------------------------------------------------------------------------------
# adiary / .datߴ⥸塼
#						(C)2007 nabe / nabe@abk.nu
#------------------------------------------------------------------------------
#ʻͻ
# http://info.2ch.net/wiki/pukiwiki.php?monazilla%2Fdat%A4%CE%BB%C5%CD%CD
#
package Satsuki::Diary::dat_read;
our $VERSION = '1.00';
#------------------------------------------------------------------------------
use Fcntl;	# for sysopen
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;
	my $self  = {};
	bless($self, $class);	# $self 򤳤Υ饹ȴϢդ
	$self->{ROBJ}      = shift;
	return $self;
}

#------------------------------------------------------------------------------
# ڥǥȥ饯
#------------------------------------------------------------------------------
sub DESTROY {
}

###############################################################################
# ᥤ롼
###############################################################################
#------------------------------------------------------------------------------
# ᡼빹Υᥤ
#------------------------------------------------------------------------------
sub main {
	my ($self) = @_;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $Diary= $ROBJ->{Diary};

	# PATH_INFO
	#  "GET /~xxx/board_name/subject.txt"
	#  "GET /~xxx/board_name/subject.txt"
	#  "GET /~xxx/board_name/dat/1181702006.dat"
	my $pinfo = $ROBJ->read_path_info();
	my $diary_id = $pinfo->[0];
	my $type     = $pinfo->[1];
	my $dat_file = $pinfo->[2];

	# read.cgi ƤӽФ
 	if ($diary_id eq 'test' && $type eq 'read.cgi') {
		return $self->browser_redirect( $diary_id );
	}

	# Ģ¸߳ǧ
	$diary_id =~ s/[^\w-]//g;
	if ($DB->find_table("${diary_id}_diary")) {
		# Ģ
		my $set = $self->{set} = $Diary->load_daybook_setting( $diary_id );
		if ($set->{enable_force} eq '0') { $diary_id = undef; }
	} elsif (($diary_id eq '-' || $diary_id eq 'x') && $Diary->{single_mode}) {
		$diary_id = $Diary->{single_mode};
	} else {
		$diary_id = undef;
	}
	if (! $diary_id) { return $self->error("Not found"); }

	# ʬ
	if ($type eq 'subject.txt') {
		return $self->subject_txt( $diary_id );
	} elsif ($type eq 'dat') {
		return $self->read_dat( $diary_id, $dat_file );
	}

	# 顼λ
	return $self->error("Not found");
}
#------------------------------------------------------------------------------
# subject.txt ν
#------------------------------------------------------------------------------
# line format: 012005866.dat<>ƥ (16)\n
# 
sub subject_txt {
	my ($self, $diary_id) = @_;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $set  = $self->{set};

	my %h;
	if ($self->{bbs_mode}) {
		$h{sort}          = 'update_tm';	# 
		$h{sort_reverse}  = 1;			# 
	} else {
		$h{sort}          = 'yyyymmdd';
		$h{sort_reverse}  = 1;			# դο
		$h{sort2}         = 'tm';
		$h{sort2_reverse} = $set->{disp_tmsort};
	}
	$h{flag} = {enable => 1};	# ɽǽΤ
	$h{select_cols} = ['pkey', 'title', 'comments'];

	my $logs = $DB->select("${diary_id}_diary", \%h);
	my @ary;
	foreach(@$logs) {
		my $c = $_->{comments}+1;
		push(@ary, "$_->{pkey}.dat<>$_->{title} ($c)\n");
	}
	# 
	$self->output_sjis( \@ary );
}

#------------------------------------------------------------------------------
# .dat ν
#------------------------------------------------------------------------------
sub read_dat {
	my ($self, $diary_id, $dat_file) = @_;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $Diary= $ROBJ->{Diary};

	# եå
	if ($dat_file !~ /^(\d+)\.dat$/) {
		$self->error("\".dat\" file name, format error");
	}
	my $pkey = $1;

	my %h;
	$h{match_int} = {'pkey' => $pkey };
	$h{limit} = 1;
	$h{flag}  = {enable => 1};	# 
	$h{select_cols} = ['pkey', 'name', 'title', 'tm', 'update_tm', 'id', 'comments', 'comments_all', 'text'];
	my $logs = $DB->select("${diary_id}_diary", \%h);
	my $day  = $logs->[0];
	if (!defined $day) {
		$self->error("\".dat\" file not found");
	}

	# ϥǡǼ
	# line format: ȥϣܤν񤭹ߤΤ
	#   Name<>mail@xxx.net<>2007/06/15() 20:03 ID:70E9FaAw<> <br>ʸ <>ȥ
	#   Name<>mail@xxx.net<>2007/06/15() 20:03 ID:70E9FaAw<> <br>ʸ <>
	my @ary;
	{
		# ʸùʥ
		$day->{text} =~ s/\n//g;
		if ($self->{allow_tags}) {
			my $tag_escape = $ROBJ->loadpm('TextParser::TagEscape', $self->{allow_tags});
			$day->{text} = $tag_escape->escape( $day->{text} );
		} else {
			$day->{text} =~ s[(href="|src=")/][$1$ROBJ->{Server_url}/]g;
		}
		# 
		my $date = $ROBJ->tm_printf('%Y/%m/%d(%a) %H:%M', $day->{tm});
		push(@ary, "$day->{name}<>$day->{category}<>$date ID:$day->{id}<> $day->{text} <>$day->{title}\n");
	}
	$Diary->{diary_id} = $diary_id;
	my $comments = $Diary->load_comments($day);	# ȥ
	foreach(@$comments) {
		my $date = $ROBJ->tm_printf('%Y/%m/%d(%a) %H:%M', $_->{tm});
		$_->{text} =~ s/\n//g;
		push(@ary, "$_->{name}<>$_->{email}<>$date ID:$_->{id}<> $_->{text} <>\n");
	}
	# 
	$ROBJ->print_lastmodified( $day->{update_tm} );
	$self->output_sjis( \@ary );
}


#------------------------------------------------------------------------------
# ֥饦Υ쥯ȡʥ֥饦ǳURL
#------------------------------------------------------------------------------
sub browser_redirect {
	my ($self) = @_;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $Diary= $ROBJ->{Diary};

	# dat.cgi/test/read.cgi?bbs=diary_id&key=213&ls=50
	my $query = $ROBJ->read_query();
	my $diary_id = $query->{bbs};
	my $pkey  = int($query->{key});
	my $path  = $self->{adiary_path};
	if (substr($path, -1) eq '/') { chop($path); }

	if ($diary_id eq $Diary->{single_mode}) {
		$diary_id = "";
	} elsif ($Diary->{subdomain_mode}) {
		$path = "http://$diary_id.$Diary->{subdomain_mode}";
		$diary_id = "";
	} else {
		$diary_id = "$diary_id/"
	}
	$pkey = "0$pkey";
	$ROBJ->redirect( "$path/$diary_id$pkey" );
}

###############################################################################
# ֥롼
###############################################################################
#------------------------------------------------------------------------------
# SJISѴƽ
#------------------------------------------------------------------------------
sub output_sjis {
	my ($self, $str) = @_;
	my $ROBJ = $self->{ROBJ};
	if (ref $str) { $str = join('', @$str); }

	# ʸѴ
	my $jcode = $ROBJ->loadpm("Jcode");
	$jcode->from_to(\$str, $ROBJ->{System_coding}, 'Shift_JIS');

	$ROBJ->print_header( "Content-Length", length($str) );
	$ROBJ->print_content_type("text/plain", 'Shift_JIS');
	print $str;
}

#------------------------------------------------------------------------------
# 顼λ
#------------------------------------------------------------------------------
sub error {
	my ($self, $err) = @_;
	$self->{ROBJ}->print_content_type("text/plain");
	print $err;
}

1;
