use strict;
#------------------------------------------------------------------------------
# http, ftp, mailto ˡץ饰
#                                                   (C)2006 nabe / nabe@abk.nu
#------------------------------------------------------------------------------
package Satsuki::TextParser::TagPlugin::Tag_http;
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# 󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;	# ɤ߼Τ
	my $ROBJ  = shift;	# ɤ߼Τ

	my $tags = shift;
	$tags->{http}   = {data  => \&http};	# [http://]   ɽ
	$tags->{https}  = {data  => \&http};	# [http://]   ɽ
	$tags->{ftp}    = {data  => \&http};	# [ftp://]    ɽ
	$tags->{mailto} = {data  => \&mailto};	# [mailto://] ɽ
}

###############################################################################
# 롼
###############################################################################
#------------------------------------------------------------------------------
# httpˡ
#------------------------------------------------------------------------------
sub http {
	my ($parser_obj, $tag, $cmd, $ary) = @_;

	my $url2 = shift(@$ary);
	# URI󥳡
	$parser_obj->uri_encode($url2);
	$cmd =~ s/\W//g;
	my $url = $url2;
	if (substr($url2,0,2) eq '//') { $url = $cmd . ':' . $url2; }
	# ͥɽ (image ץ饰󤢤
	my $tags = $parser_obj->{tags};
	if ($ary->[0] eq 'image' && $tags->{"$cmd:image"} && $tags->{'=image'}) {
		# 裱URLǼ
		$ary->[0] = substr($url2, 2);	# //xxx.dom.jp  xxx.dom.jp
		$cmd .= ':image';
		$tag  = $tags->{$cmd};
		my $image = $tags->{'=image'};
		return &$image($parser_obj, $tag, $cmd, $ary);
	}
	# °/̾
	my $attri = $parser_obj->make_attri($ary, $tag, 'http');
	my $name  = $parser_obj->make_name ($ary, $url);

	return "<a href=\"$url\"$attri>$name</a>";
}
#--------------------------------------------------------------------
# mailtoˡ
#--------------------------------------------------------------------
sub mailto {
	my ($parser_obj, $tag, $cmd, $ary) = @_;

	my $mail = shift(@$ary);
	$mail =~ s/\"\'/'%' . unpack('H2',$1)/eg;
	$mail = 'mailto:' . $mail;
	my $attri = $parser_obj->make_attri($ary, $tag);
	my $name  = $parser_obj->make_name ($ary, $mail);

	return "<a href=\"$mail\"$attri>$name</a>";
}


1;
