#!/usr/local/bin/perl
require 5.004;
use strict;
#------------------------------------------------------------------------------
# ǡݡ for JUGEM(xml)
#                                                   (C)2006 nabe / nabe@abk.nu
#------------------------------------------------------------------------------
# ŪˡMovable Type°ĥơXML˼᤿褦ʹʸǤ
#
package Satsuki::Diary::ImportJUGEM;
use Time::Local;
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;
	my $self  = {};
	bless($self, $class);		# $self 򤳤Υ饹ȴϢդ
	$self->{ROBJ}  = shift;

	return $self;
}

#------------------------------------------------------------------------------
# ڥǥȥ饯
#------------------------------------------------------------------------------
sub DESTROY {
}
###############################################################################
# ǡݡ
###############################################################################
#------------------------------------------------------------------------------
# JUGEMΥǡݡ
#------------------------------------------------------------------------------
sub import {
	my ($self, $diary_obj, $form) = @_;
	my $ROBJ = $self->{ROBJ};
	my $input_coding = 'UTF-8';

	# ǡå
	my $data = $form->{import}->{data};
	delete $form->{import};
	my $check_data = substr($data, 0, 1024);
	if ($check_data =~ /<\?xml .*? encoding="([\w\-]*)".*?\?>.*<blog>/s) {
		$input_coding = $1 || $input_coding;
		$input_coding =~ tr/a-z/A-Z/;
	} else {
		$ROBJ->message('Data format error (%s)', 'JUGEM');
		return -1;
	}

	# ʸѴ
	my $system_coding = $ROBJ->{System_coding};
	if ($system_coding ne $input_coding) {
		my $jcode = $ROBJ->loadpm('Jcode');
		$jcode->from_to(\$data, $input_coding, $system_coding);
	}

	# CDATA
	my @cdata;
	$data =~ s|<!\[CDATA\[(.*?)\]\]>|push(@cdata, $1),"<c$#cdata>"|seg;
	# ȥ꡼
	my @days;
	$data =~ s|<entry>(.*?)</entry>|push(@days, $1),''|seg;
	undef $data;

	# 
	my $change_hour =  $form->{JUGEM_change_hour_int};
	my $lf2br       =  $form->{JUGEM_lf2br};
	my $lf2br_force =  $form->{JUGEM_lf2br_force};
	my $tz          = ($form->{JUGEM_tz} +0) * 3600;
	if ($lf2br eq '') { $lf2br=1; }

	#---------------------------------------------------------------------
	# βϤ¸
	#---------------------------------------------------------------------
	my %parser_cache;
	my $imports = 0;
	foreach my $log (@days) {
		#-------------------------------------------------------------
		# ȡȥåХå
		#-------------------------------------------------------------
		my $comments='';
		my $trackbacks='';
		$log =~ s/<comments>(.*?)<\/comments>/$comments=$1,''/se;
		$log =~ s/<trackbacks>(.*?)<\/trackbacks>/$trackbacks=$1,''/se;

		#-------------------------------------------------------------
		# ǡβ
		#-------------------------------------------------------------
		my %diary;
		$log =~ s|<(\w+)>(.*?)</\1>|$diary{$1}=$2,''|seg;
		&xml_decode( \%diary, \@cdata );
		# Ѵ
		my $tm = $diary{tm} = &date2utc($diary{date}, $tz);
		if (! $tm) { next; }	# DATE ʤǡ̵
		my $h = $ROBJ->time2timehash( $diary{tm}, $change_hour );
		$diary{year} = $h->{year};
		$diary{mon}  = $h->{mon};
		$diary{day}  = $h->{day};
		# ɮ
		$diary{name} = $diary{author};
		# ե饰Ϥβ
		if ($diary{status} =~ /publish/i) { $diary{enable}=1; } # ɽ
		if ($diary{status} =~ /draft/i)   { $diary{enable}=0; } # ɽ
		if (exists $diary{allowcomments}) {	# sb  0:Ե 1: 2:׾ǧ
			if($diary{allowcomments}) { $diary{allowcomments}=1; } else { $diary{allowcomments}=0; }
		}
		if (exists $diary{allowpings})    {	# sb  0:Ե 1: 2:׾ǧ
			if($diary{allowpings}) { $diary{allowpings}=1; } else { $diary{allowpings}=0; }
		}
		$diary{allow_tb}  = $diary{allowpings};
		$diary{allow_com} = $diary{allowcomments};

		#-------------------------------------------------------------
		# Ȥβ
		#-------------------------------------------------------------
		my @comments;
		if ($comments ne '') {
			my @ary;
			$comments =~ s/<comment>(.*?)<\/comment>/push(@ary, $1),''/seg;
			foreach(@ary) {
				my %h;
				$_ =~ s|<(\w+)>(.*?)</\1>|$h{$1}=$2,''|seg;
				&xml_decode( \%h, \@cdata );
				$h{tm}     = &date2utc($h{date}, $tz);
				$h{text}   = $h{description};
				delete $h{description};

				$h{text} =~ s/<br( \/)?>/\n/g;	# <br>\n ᤹
				push(@comments, \%h);
			}
		}

		#-------------------------------------------------------------
		# ȥåХåβ
		#-------------------------------------------------------------
		my @trackbacks;
		if ($trackbacks ne '') {
			my @ary;
			$trackbacks =~ s/<trackback>(.*?)<\/trackback>/push(@ary, $1),''/seg;
			foreach(@ary) {
				my %h;
				$_ =~ s|<(\w+)>(.*?)</(\1)>|$h{$1}=$2,''|seg;
				&xml_decode( \%h, \@cdata );
				push(@trackbacks, \%h);
			}
		}

		#-------------------------------------------------------------
		# JUGEMǡadiaryŬʥ
		#-------------------------------------------------------------
		my $convert_breaks = $diary{convertbreaks};
		if ($convert_breaks eq '' || $lf2br_force) { $convert_breaks = $lf2br; }

		my $body    = $diary{description};
		my $ex_body = $diary{sequel};
		while(substr(   $body, -1) eq "\n") { chop(   $body); }
		while(substr($ex_body, -1) eq "\n") { chop($ex_body); }
		if ($body =~ /^\s*$/) { next; }		# ʸʤǡ̵
		# Ƭ ==== 򥨥
		$body    =~ s/\n====/ ====/g;
		$ex_body =~ s/\n====/ ====/g;
		if ($ex_body !~ /^\s*$/) {		# ɵ³ɤǽ
			$body .= "\n\n====\n$ex_body";
		}
		# ⡼ɡ
		if ($convert_breaks) { $diary{parser} = 'simple_p'; }
				else { $diary{parser} = 'simple';   }
		# <br /> 
		$body    =~ s/<br( \/)?>//g;
		# ѿ˳Ǽ
		$diary{text} = $body;
		$body = $ex_body = undef;
		delete $diary{description};
		delete $diary{sequel};

		#-------------------------------------------------------------
		# ǡ¸
		#-------------------------------------------------------------
		if (! $diary_obj->save_diary(\%parser_cache, \%diary, \@comments, \@trackbacks)) {	# ¸
			$imports ++;
		}
	}
	$diary_obj->{exists_diaries} = $#days +1;
	$diary_obj->{import_diaries} = $imports;
	return 0;
}

###############################################################################
# ֥롼
###############################################################################
#------------------------------------------------------------------------------
# xmlΥ󥳡ɤ᤹
#------------------------------------------------------------------------------
sub xml_decode {
	my ($h, $cdata) = @_;
	while(my ($k,$v) = each(%$h)) {
		if ($v =~ /^<c(\d+)>$/) {
			$v = $cdata->[$1];
		} else {
			$v =~ s/&lt;/</g;
			$v =~ s/&gt;/>/g;
			$v =~ s/&quot;/"/g;
			$v =~ s/&amp;/&/g;
			$v =~ s/&#(\d+);/chr($1)/eg;
		}
		$h->{$k} = $v;
	}
	return $h;
}
#------------------------------------------------------------------------------
# JUGEMեǡ UTC Ѵ
#------------------------------------------------------------------------------
#	MM/DD/YYYY hh:mm:ss
#	MM/DD/YYYY hh:mm:ss AM/PM
sub date2utc {
	my $date = shift;
	my $tz   = shift;
	if ($date !~ /^(\d\d\d\d)\/(\d\d)\/(\d\d) (\d\d):(\d\d):(\d\d)(.*)/) { return ; }
	my $year = $1;
	my $mon  = $2;
	my $day  = $3;
	my $hour = $4;
	my $min  = $5;
	my $sec  = $6;
	my $add  = $7;	# 
	if ($add =~ /\+(\d\d):(\d\d)/) { $tz =  $1*3600+$2*60; }
	if ($add =~ /\-(\d\d):(\d\d)/) { $tz = -$1*3600-$2*60; }
	return (Time::Local::timegm($sec,$min,$hour,$day,$mon-1,$year) - $tz);
}

1;
