use strict;
#------------------------------------------------------------------------------
# adiaryͭˡץ饰
#                                                   (C)2006 nabe / nabe@abk.nu
#------------------------------------------------------------------------------
package Satsuki::TextParser::TagPlugin::Tag_adiary;
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# 󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;	# ɤ߼Τ
	my $ROBJ  = shift;	# ɤ߼Τ

#this = >adiary:this
#key  = >adiary:key
#id   = >adiary:id
#day  = >adiary:day
	my $tags = shift;
	$tags->{"adiary:this"} = {data => \&adiary_key, _this =>1};
	$tags->{"adiary:key"}  = {data => \&adiary_key, _key  =>1};
	$tags->{"adiary:id"}   = {data => \&adiary_key, _id   =>1};
	$tags->{"adiary:day"}  = {data => \&adiary_day};
	$tags->{"adiary:sectioncategory"} = {data => \&adiary_sectioncategory};
}

###############################################################################
# 롼
###############################################################################
#------------------------------------------------------------------------------
# adiary this/key/id ˡ
#------------------------------------------------------------------------------
sub adiary_key {
	my ($parser_obj, $tag, $cmd, $ary) = @_;
	my $Diary   = $parser_obj->{ROBJ}->{Diary};
	my $replace = $parser_obj->{replace_data};

	# IDˡ
	my $url;
	my $name;
	if ($tag->{_id}) {
		my $id = shift(@$ary);
		$url   = $Diary->get_daybook_url($id);
		$name .= $id;
	} elsif ($tag->{_this}) {
		$url = $parser_obj->{thisurl};
	} else {
		$url = $replace->{myself2};
	}
	if ($tag->{_key} || $tag->{_id}) {
		#  pkey/link_key 
		my $link_key = shift(@$ary);
		if ($link_key ne '') {
			$name .= (($name ne '')?':':'') . $link_key;
			if ($link_key =~ /^[\d]+$/) {
				if ($link_key < 10000000) { $link_key = "0" . int($link_key); }
			} elsif (substr($link_key,0,1) eq '/' || $link_key =~ /\"\'/) {
				return "(key error)";	# error
			} else {
				$parser_obj->form_encode($link_key);
			}
			$url .= $link_key;
		}
	}
	return &adiary_link_base($parser_obj, $tag, $url, $name, $ary);
}

#------------------------------------------------------------------------------
# adiary day ˡ
#------------------------------------------------------------------------------
sub adiary_day {
	my ($parser_obj, $tag, $cmd, $ary) = @_;
	my $ROBJ  = $parser_obj->{ROBJ};
	my $Diary = $ROBJ->{Diary};
	my $replace = $parser_obj->{replace_data};

	# ǥե = 
	my $year = $parser_obj->{thisyear};
	my $mon  = $parser_obj->{thismon};
	my $day  = $parser_obj->{thisday};
	# 
	my $url;
	my $name;
	if ($ary->[0] !~ /^[\d\/\-]*$/ && $ary->[0] =~ /^[\w\-]+$/) {
		# ID ꤵƤ
		my $diary_id = shift(@$ary);
		$url  = $Diary->get_daybook_url($diary_id);
		$name = $diary_id;
	} else {
		$url = $replace->{myself2};
	}

	# ջ
	my $opt = shift(@$ary);
	my $name2;
	if ($opt =~ /^0\d+$/) {		# 0nnnnn : pkey
		$url  .= $opt;
		$name2 = int($opt);

	} elsif ($opt > 99999999) {	# nnnnnnnn : tm
		$opt   = int($opt);
		$url  .= $opt;
		$name2 = $ROBJ->tm_printf("%Y/%m/%d", $opt);

	} elsif ($opt =~ /^\d+$/) {	# DD MDD MMDD
		$name2 = $opt;
		   if ($opt <   100) { $day=$opt; }
		elsif ($opt <  1000) { $day=substr($opt, 1); $mon=substr($opt, 0, 1); }
		elsif ($opt < 10000) { $day=substr($opt, 2); $mon=substr($opt, 0, 2); }
		$url .= sprintf("%04d%02d%02d", $year, $mon, $day);

	} elsif ($opt =~ /^[\d\/\-]+$/) {		#   /
		$name2 =  $opt;
		$opt   =~ tr/-/\//;
		my @ymd = split('/', $opt);
		if (999 < $ymd[$#ymd]) {	# MM/DD/YYYY MM/YYYY
			my $year = pop(@ymd);
			unshift(@ymd, $year);
		}
		if (999 < $ymd[0] && $ymd[0] < 10000 && $ymd[1] < 13 && !$ymd[2]) {
			# YYYY/MM
			$url .= sprintf("%04d%02d", $ymd[0], $ymd[1]);
		} else {
			# YYYY/MM/DD YY/MM/DD MM/DD
			my $pop = int(pop(@ymd));
			if (0<$pop && $pop<100) { $day=$pop; $pop = int(pop(@ymd)); }
			if (0<$pop && $pop<100) { $mon=$pop; $pop = int(pop(@ymd)); }
			if (0<$pop && $pop<99)  { $year = 2000 + $pop; }
			elsif (1999 < $pop && $pop <10000) { $year = $pop; }
			$url .= sprintf("%04d%02d%02d", $year, $mon, $day);
		}

	} elsif ($name eq '') {
		$name2 = 'today';
		$url .= sprintf("%04d%02d%02d", $year, $mon, $day);
		if (defined $opt) { unshift(@$ary, $opt); }
	} else {
		unshift(@$ary, $opt);
	}
	# name 
	if ($name2 ne '') {
		if ($name ne '') { $name .= ':'; }
		$name .= $name2;
	}
	return &adiary_link_base($parser_obj, $tag, $url, $name, $ary);
}

#------------------------------------------------------------------------------
# adiary  ˡΥ١
#------------------------------------------------------------------------------
sub adiary_link_base {
	my ($parser_obj, $tag, $url, $name, $ary) = @_;

	# 󥫡̾a name˻
	if ($ary->[0] =~ /^\#[\w\.\-]*$/) {
		$name .= $ary->[0];
		$url  .= shift(@$ary);
	}
	# °
	my $attri = $parser_obj->make_attri($ary, $tag, 'http');
	# ̾
	if ($ary->[0] ne '') { $name=join(':', @$ary); }
	return "<a href=\"$url\"$attri>$name</a>";
}


#------------------------------------------------------------------------------
# adiary:search ˡ
#------------------------------------------------------------------------------
# *[xxx][yyy]
# ȤФˡǸƤФ롼
sub adiary_sectioncategory {
	my ($parser_obj, $tag, $cmd, $ary) = @_;
	my $replace = $parser_obj->{replace_data};
	my $name   = join(':', @$ary);
	my $search = "[$name]";
	$search =~ s/"//g;
	if ($search =~ /\s/) { $search="%22$search%22"; }
	# tag
	my $title=$tag->{title};
	if ($title ne '') { $title=" title=\"$title\""; }
	return "<a href=\"$replace->{myself2}&amp;search?all=2&amp;word=$search\" class=\"sectioncategory\"$title>[$name]</a>";

	#ǤʤΤǲΤ褦ˤƤϤʤ
	# return "[<a>$name</a>]";
}

1;
