use strict;
eval { require Time::HiRes; };
#-------------------------------------------------------------------------------
# ٥ޡ
#						(C)2005-03 nabe / nabe@abk.nu
#-------------------------------------------------------------------------------
package Satsuki::Timer;
our $VERSION = '1.00';
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;
	my $self  = {};
	bless($self, $class);	# $self 򤳤Υ饹ȴϢդ
	return $self;
}

#------------------------------------------------------------------------------
# ڥǥȥ饯
#------------------------------------------------------------------------------
sub DESTROY {
}

###############################################################################
# ᥤ롼
###############################################################################
#------------------------------------------------------------------------------
# ޡλư
#------------------------------------------------------------------------------
sub start {
	if (!defined $Time::HiRes::VERSION) { return; }
	my $self = shift;
	my ($tm_name) = @_;
	my $p_time = $self->{"pause_$tm_name"} + 0;
	$self->{"pause_$tm_name"} = 0;
	if ($p_time) {
		$self->{"timer_$tm_name"} = Time::HiRes::time() - $p_time;
	} else {
		$self->{"timer_$tm_name"} = Time::HiRes::time();
	}
	return $p_time;
}

#-------------------------------------------------------------------------------
# ޡγǧ
#-------------------------------------------------------------------------------
sub check {
	if (!defined $Time::HiRes::VERSION) { return; }
	my $self = shift;
	my ($tm_name) = @_;
	if (! $self->{"timer_$tm_name"}) { return 0; }
	if (  $self->{"pause_$tm_name"}) { return $self->{"pause_$tm_name"}; }
	return Time::HiRes::time() - $self->{"timer_$tm_name"};
}

#-------------------------------------------------------------------------------
# ޡ
#-------------------------------------------------------------------------------
sub stop {
	if (!defined $Time::HiRes::VERSION) { return; }
	my $self = shift;
	my ($tm_name) = @_;
	if (! $self->{"timer_$tm_name"}) { return; }
	my $diff = $self->check($tm_name);
	if (defined $diff) { $self->{"pause_$tm_name"} = $diff; }
 	return $diff;
}

#-------------------------------------------------------------------------------
# ޡΥꥢ
#-------------------------------------------------------------------------------
sub clear {
	if (!defined $Time::HiRes::VERSION) { return; }
	my $self = shift;
	my ($tm_name) = @_;
	undef $self->{"tm_$tm_name"};
	undef $self->{"pause_$tm_name"};
	return ;		# pause time
}

#-------------------------------------------------------------------------------
# ͼ
#-------------------------------------------------------------------------------
sub now {
	if (!defined $Time::HiRes::VERSION) { return; }
	return Time::HiRes::time();
}



1;
