#
# 2006/04/07 (c)nabe@abk
#
# This handler is timestamp print to log for ModPerl2 only.
# OɃ^CX^v\邽߂̃_~[nh
#	Reload.pm ̓ƂAǂ܂łP̃NGXgsȂ̂ŁB
#
package patches::Apache2::Reload;
use strict;
use Apache2::Const -compile => qw(OK);

sub get_date {
	my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
	return sprintf("%04d/%02d/%02d %02d:%02d:%02d ",$year+1900, $mon+1, $mday, $hour, $min, $sec);
}

sub handler {
	my $obj = shift;
	# check Debug flag for Apache2::Reload
	my $DEBUG = $obj->dir_config("ReloadDebug");
	if ($DEBUG !~ /[Oo][Nn]/) { return Apache2::Const::OK; }

	my $date = get_date();
	warn ("$date --- by " . __PACKAGE__ . "\n");

	return Apache2::Const::OK;
}

1;
__END__
