////////////////////////////////////////////////////////////////////////////////
// 饤ɥ硼
//   Copyright(C) 2008 ꤫/꤫
////////////////////////////////////////////////////////////////////////////////

album.view.SlideView = {
	current : -1,
	first: true,
	timerid: null,
	isVisible: false,

	create: function(view) {
		var left, right, stage, img, catalog;
		left = document.createElement('div');    left.id = '_SlideViewStage_left';
		if(album.util.isIE){ left.style.backgroundColor  = 'pink'; left.style.filter  = 'alpha(opacity=0)'; }
		album.util.addEvent(left,  'mouseover', album.util.closure(this._Stage_mouseover, null));
		album.util.addEvent(left,  'mouseout',  album.util.closure(this._Stage_mouseout, null));
		album.util.addEvent(left,  'click',     album.util.closure(this._Stage_click, -1));
		view.appendChild(left);

		right = document.createElement('div');   right.id = '_SlideViewStage_right';
		if(album.util.isIE){ right.style.backgroundColor = 'pink'; right.style.filter = 'alpha(opacity=0)'; }
		album.util.addEvent(right, 'mouseover', album.util.closure(this._Stage_mouseover, null));
		album.util.addEvent(right, 'mouseout',  album.util.closure(this._Stage_mouseout, null));
		album.util.addEvent(right, 'click',     album.util.closure(this._Stage_click, 1));
		view.appendChild(right);

		left  = document.createElement('div');   left.id = '_SlideViewCatalog_left';
		if(album.util.isIE){ left.style.backgroundColor  = 'pink'; left.style.filter  = 'alpha(opacity=0)'; }
		album.util.addEvent(left,  'mouseover', album.util.closure(this._Catalog_mouseover, 'left'));
		album.util.addEvent(left,  'mouseout',  album.util.closure(this._Catalog_mouseout,  'left'));
		view.appendChild(left);

		right = document.createElement('div');   right.id = '_SlideViewCatalog_right';
		if(album.util.isIE){ right.style.backgroundColor = 'pink'; right.style.filter = 'alpha(opacity=0)'; }
		album.util.addEvent(right, 'mouseover', album.util.closure(this._Catalog_mouseover, 'right'));
		album.util.addEvent(right, 'mouseout',  album.util.closure(this._Catalog_mouseout,  'right'));
		view.appendChild(right);

		stage = document.createElement('div');   stage.id = '_SlideViewStage';
		stage.style.height = 400+'px'; stage.style.maxHeight = 400+'px';
		img = document.createElement('img');     img.id = '_SlideViewImage'; img.src = spacer;
		stage.appendChild(img);

		catalog = document.createElement('div'); catalog.id = '_SlideViewCatalog';

		view.appendChild(stage);
		view.appendChild(catalog);

		this.reset();
	},
	reset: function(){
		var catalog = document.getElementById('_SlideViewCatalog');

		var obja, obji, img;
		for(var i in album.imgs){
			img = album.imgs[i];

			obji = document.createElement('img');
			obji.src = img['thumbnail'];
			obji.setAttribute('title', img['name']);
			obja = document.createElement('a');
			obja.href = '#';

			album.util.addEvent(obja, 'click', album.util.closure(this._Catalog_click, i));

			obja.appendChild(obji);
			catalog.appendChild(obja);
		}
	},
	show: function(){
		album.util.addEvent(document, 'keydown', album.view.SlideView._Slide_key);
		this.isVisible = true;
		if(this.first){
			album.resize();
			this.first = false;
		}

		// hide some element
		var obj;
		obj = document.getElementById('sidebar');
			obj.style.display='none';
		obj = document.getElementById('iimagelist2');
			obj.style.display='none';

		// resize
		var height = album._resizeHeight();
		var width  = album._resizeWidth();
		this.resize(width, height);
	},
	hide: function(){
		album.util.delEvent(document, 'keydown', album.view.SlideView._Slide_key);
		this.isVisible = false;

		// show sidebar
		var obj;
		obj = document.getElementById('sidebar');
			obj.style.display='block';
		obj = document.getElementById('iimagelist2');
			obj.style.display='block';

		album._resizeHeight();
		album._resizeWidth();
	},
	resize: function(width, height){
		var stage = document.getElementById('_SlideViewStage');
		var stageheight;
		width--; height--;

		var button, i, c, size;
		if(stage){
			stageheight = height - (img_max_size + 30);
			stageheight = (stageheight < img_max_size) ? img_max_size : stageheight;
			stage.style.maxHeight = stageheight+'px';
			stage.style.height = stageheight+'px';
			stage.style.width  = width-1+'px';
		}
		i = document.getElementById('_SlideViewImage');
		if(i){ i.style.maxHeight = stageheight-2+'px'; i.style.maxWidth  = width-2+'px'; }
		c = document.getElementById('_SlideViewCatalog');
		if(c){ c.style.width = width+'px'; c.style.height = img_max_size+28+'px'; }
		size = album.util.getPosition(c);

		button = document.getElementById('_SlideViewStage_left');
		if(button){ button.style.height = stageheight+'px'; button.style.left = '0px'; }
		button = document.getElementById('_SlideViewStage_right');
		if(button){ button.style.height = stageheight+'px'; button.style.left = width-100+'px'; }

		button = document.getElementById('_SlideViewCatalog_left');
		if(button){ button.style.top = size.y+1+'px'; button.style.height = img_max_size+12 +'px'; button.style.left = '0px'; }
		button = document.getElementById('_SlideViewCatalog_right');
		if(button){ button.style.top = size.y+1+'px'; button.style.height = img_max_size+12 +'px'; button.style.left = width-50+'px'; }
	},

	// ٥
	_Stage_mouseover: function(e){
		var elem = e.srcElement || e.target;
		if(elem.style.backgroundImage == 'none') elem.style.backgroundImage = 'url('+mask+')';
		if(album.util.isIE){ elem.style.backgroundColor = 'transparent'; elem.style.filter = ''; }
	},
	_Stage_mouseout: function(e){
		var elem = e.srcElement || e.target;
		if(elem.style.backgroundImage != 'none') elem.style.backgroundImage = 'none';
		if(album.util.isIE){ elem.style.filter = 'alpha(opacity=0)'; elem.style.backgroundColor = 'pink'; }
	},
	_Stage_click: function(e, d){
		var next = parseInt(album.view.SlideView.current) + d;
		if(next < 0)                  next = 0;
		if(album.imgs.length <= next) next = album.imgs.length-1;
		album.view.SlideView._Catalog_click(e, next);
	},

	_Catalog_mouseover: function(e, d){
		var elem = e.srcElement || e.target;
		if(elem.style.backgroundImage == 'none') elem.style.backgroundImage = 'url('+mask+')';
		if(album.util.isIE){ elem.style.backgroundColor = 'transparent'; elem.style.filter = '';}

		if(d == 'left')       this.timerid = setInterval('album.view.SlideView._Catalog_scroll(-4)', 60);
		else if(d == 'right') this.timerid = setInterval('album.view.SlideView._Catalog_scroll(4)',  60);
	},
	_Catalog_mouseout: function(e,d){
		var elem = e.srcElement || e.target;
		if(elem.style.backgroundImage != 'none') elem.style.backgroundImage = 'none';
		if(album.util.isIE){ elem.style.filter = 'alpha(opacity=0)'; elem.style.backgroundColor = 'pink'; }

		if(this.timerid) clearInterval(this.timerid);
		this.timerid = null;
	},
	_Catalog_click: function(e, idx){
		var img = document.getElementById('_SlideViewImage');

		if(img && idx != album.view.SlideView.current){
//			idx = album._convindex(idx);
			img.src = album.imgs[idx]['path'];
			img.style.width  = 'auto'; img.style.height = 'auto'; // For IE
			album.replaceinfo(album.imgs[idx]['index']);

			// scroll
			var obj = document.getElementById('_SlideViewCatalog');
			var imgs = obj.getElementsByTagName('A');
				img = imgs[idx];
			var size = album.util.getPosition(img);
				size.x -= album.util.getPosition(obj).x;
			if(size.x < obj.scrollLeft)                             obj.scrollLeft = size.x;
			else if(obj.scrollLeft+obj.clientWidth < size.x+size.w) obj.scrollLeft = size.x+size.w - obj.clientWidth;

			// focus
			img.focus();
			img = img.getElementsByTagName('IMG')[0];
			album.util.addClass(img, 'focus');
			if(album.view.SlideView.current >= 0){
				img = imgs[album.view.SlideView.current].getElementsByTagName('IMG')[0];
				album.util.delClass(img, 'focus');
			}

			album.view.SlideView.current = idx;
		}
	},
	_Catalog_scroll: function(d){
		var obj = document.getElementById('_SlideViewCatalog');
		var pos = obj.scrollLeft + d;
		if(pos < 0)                               pos = 0;
		if(obj.scrollWidth-obj.clientWidth < pos) pos = obj.scrollWidth-obj.clientWidth;
		obj.scrollLeft = pos;
	},

	_Slide_key: function(e){
		var b = false;
		switch(e.keyCode){
			case 35: b=true; album.view.SlideView._Catalog_click(e, album.imgs.length-1); break; // end
			case 36: b=true; album.view.SlideView._Catalog_click(e, 0); break;                   // home
			case 37: b=true; album.view.SlideView._Stage_click(e, -1);  break;                   // left
			case 39: b=true; album.view.SlideView._Stage_click(e,  1);  break;                   // right
			case 33: b=true; album.view.SlideView._Stage_click(e, -5);  break;                   // page up
			case 34: b=true; album.view.SlideView._Stage_click(e,  5);  break;                   // page down
		}
		if(b) album.util.preventDefault(e);
	}
}

// system check
if(navigator.appName == 'Microsoft Internet Explorer'){
	var x = navigator.appVersion.indexOf("MSIE", 0);
	x = navigator.appVersion.substring(x+5, x+9);
	if(parseInt(x) < 7){
		album.view.SlideView = {
			create: function(view) {
				var obj = document.createElement('div');
				obj.appendChild(document.createTextNode('Sorry, slideshow does not support IE '+x+'. Please update to IE 7 or later.'));
				view.appendChild(obj);
			}
		};
	}
}
